﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

       


        IList<Point> line = new List<Point>();

        private void Form1_Load(object sender, EventArgs e)
        {
            this.SetStyle(ControlStyles.UserPaint, true);
            this.SetStyle(ControlStyles.AllPaintingInWmPaint, true); // 禁止擦除背景.
            this.SetStyle(ControlStyles.DoubleBuffer, true);
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            //for (int i = 0; i < line.Count; i += 1)
            //{
            //    if (i >= line.Count - 1)
            //        break;
            //    e.Graphics.DrawLine(Pens.Red, line[i], line[i + 1]);
            //}
            for (int i = 0; i < lines.Count; i += 2)
            {
                if (i >= lines.Count - 1)
                    break;
                e.Graphics.DrawLine(Pens.Red, lines[i], lines[i + 1]);
            }
            foreach (Rectangle rec in recs)
            {
                e.Graphics.DrawRectangle(Pens.Green, rec);
            }

            if (!mouseDown)
                return;
            if (type == toolType.line)
                e.Graphics.DrawLine(Pens.Red, startMouse, tmpMouse);
            if (type == toolType.rec)
                e.Graphics.DrawRectangle(Pens.Green, new Rectangle(startMouse, new Size
                                (tmpMouse.X - startMouse.X, tmpMouse.Y - startMouse.Y)));
        }
        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            //line.Add(e.Location);
            tmpMouse = e.Location;
            Invalidate();
        }
        Point tmpMouse = new Point();
        
        IList<Point> lines = new List<Point>();
        IList<Rectangle> recs = new List<Rectangle>();
        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            startMouse = e.Location;
            mouseDown = true;
        }
        bool mouseDown = false;

        Point startMouse=new Point();

        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            switch (type)
            {
                case toolType.line: {
                    lines.Add(startMouse);
                    lines.Add(e.Location);
                    break;
                }
                case toolType.rec:
                    {
                        recs.Add(new Rectangle(startMouse, new Size
                            (e.Location.X - startMouse.X, e.Location.Y - startMouse.Y)));
                        break;
                    }
            }
            mouseDown = false;
            Invalidate();
        }

        //工具切换效果
        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            for (int i = 0; i < menuStrip1.Items.Count; i++)
            {
                menuStrip1.Items[i].BackColor = Color.FromName("Control");
            }
            e.ClickedItem.BackColor = Color.Green;
        }

        private void 画线ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            type = toolType.line;
        }

        private void 铅笔ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            type = toolType.pencil;
        }
        toolType type=toolType.line;
        enum toolType
        {
            line, pencil,rec
        }

        private void 画框ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            type = toolType.rec;
        }
    }
}
